; ::::::::::::::::::::
; CURVATURE MAP TOOL
; ::::::::::::::::::::

(define (deos-NormalToCurvature inImg inLayer UI_KeepLayer)
	(let*
		(	
			; VARIABLES
			(originLayer (car (gimp-drawable-get-name inLayer)))
			(crvtMaskColor '(125 125 125))
		)
		
		; START PROCESS ::::::::::::::::::
		(gimp-context-push)
		(gimp-image-undo-group-start inImg)
		

		; CURVATRURE MAP ::::::::::::::::::

			(set! originLayer (car (gimp-layer-copy inLayer FALSE)))
			(gimp-image-add-layer inImg originLayer -1)
			(gimp-drawable-set-name originLayer "Cavity")
			(gimp-drawable-extract-component originLayer 1 FALSE FALSE)	; Red 0, Green 1, Blue 2 | Inverted | linear
			(plug-in-emboss RUN-NONINTERACTIVE inImg originLayer 270 15 2 TRUE)	; Azim, Elev, Depth, BumpMap/Emboss

			(set! originLayer (car (gimp-layer-copy inLayer FALSE)))
			(gimp-image-add-layer inImg originLayer -1)
			(gimp-drawable-set-name originLayer "CavityComplement")
			(gimp-drawable-extract-component originLayer 0 FALSE FALSE)
			(gimp-invert originLayer)
			(plug-in-emboss RUN-NONINTERACTIVE inImg originLayer 180 130 2 TRUE)
			(gimp-layer-set-mode originLayer LAYER-MODE-OVERLAY)

			(gimp-image-merge-down inImg originLayer 0)

		; : : : : : : : : : : : : : : : : : 

		; Keep Original Layer
		(if (= UI_KeepLayer FALSE)
			(gimp-image-remove-layer inImg inLayer)
		)


		; EDNS PROGRESS ::::::::::::::::::
		(gimp-progress-end)
		(gimp-image-undo-group-end inImg)
		(gimp-displays-flush)
		(gimp-context-pop)

	)

)

; UI OPTIONS
(script-fu-register "deos-NormalToCurvature"
		"Normal to Curvature Map"
		"From a Normal Map create a Curvature Map"
		"Deo"
		"Deo"
		"Feb, 2024"
		"RGB*"
		SF-IMAGE			"image"										0
		SF-DRAWABLE		"drawable"								0
		SF-TOGGLE			"Keep Original Layer?"		TRUE
)

(script-fu-menu-register 	"deos-NormalToCurvature"
													"<Image>/Filters/Deo's Tools")